package  
{
	import flare.basic.*;
	import flare.core.*;
	import flare.loaders.*;
	import flare.materials.*;
	import flare.materials.filters.*;
	import flare.primitives.*;
	import flare.utils.*;
	import flash.display.*;
	import flash.display3D.*;
	import flash.events.*;
	import flash.geom.*;
	import flash.utils.*;
	
	[SWF( width = 800, height = 450, frameRate = 60 )]
	
	/**
	 * @author Ariel Nehmad
	 */
	public class SecondCamera extends Sprite 
	{
		[Embed(source = "../bin/skybox2b.png", mimeType = "application/octet-stream")] private var skybox:Class;
		
		private var scene:Scene3D;
		private var teapot:Pivot3D;
		private var chess:Pivot3D;
		
		private var secondCamera:Camera3D;
		private var quad:Quad;
		
		public function SecondCamera() 
		{
			scene = new Viewer3D( this, null, 0.3 );
			scene.antialias = 2;
			scene.autoResize = true;
			scene.registerClass( ZF3DLoader );
			scene.addEventListener( Scene3D.PROGRESS_EVENT, progressEvent );
			scene.addEventListener( Scene3D.COMPLETE_EVENT, completeEvent );
			scene.addChild( new SkyBox( new skybox ) )
			
			chess = scene.addChildFromFile( "chess2.zf3d" );
			teapot = scene.addChildFromFile( "teapot2.zf3d" );
			
			secondCamera = new Camera3D( "secondCamera" );
			secondCamera.viewPort = new Rectangle( 100, 100, 200, 200 );
			secondCamera.z = -100;
			
			quad = new Quad( "background", 100, 100, 200, 200 );
		}
		
		private function progressEvent(e:Event):void 
		{
			//trace( scene.loadProgress );
		}
		
		private function completeEvent(e:Event):void 
		{
			trace( "complete" );
			
			teapot.parent = null;
			
			scene.addEventListener( Scene3D.POSTRENDER_EVENT, postRenderEvent );
		}
		
		private function postRenderEvent(e:Event):void 
		{
			teapot.rotateY( -0.5 );
			
			// draws the backgound.
			quad.draw();
			
			scene.context.clear( 0, 0, 0, 1, 1, 0, Context3DClearMask.DEPTH );
			scene.setupFrame( secondCamera );
			teapot.draw();
		}
	}
}